package org.nuiton.topia.test.ano1882;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaTestDAOHelper.TopiaTestEntityEnum;
import org.nuiton.topia.persistence.TopiaDAOImpl;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class FrenchCompanyDAOAbstract<E extends FrenchCompany> extends TopiaDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)FrenchCompany.class;
    }

    @Override
    public TopiaTestEntityEnum getTopiaEntityEnum() {
        return TopiaTestEntityEnum.FrenchCompany;
    }

    public E findBysIREN(SIREN v) throws TopiaException {
        E result = findByProperty(FrenchCompany.PROPERTY_S_IREN, v);
        return result;
    }

    public List<E> findAllBysIREN(SIREN v) throws TopiaException {
        List<E> result = findAllByProperty(FrenchCompany.PROPERTY_S_IREN, v);
        return result;
    }

    public E findContainssIRET(SIRET v) throws TopiaException {
        E result = findContains(FrenchCompany.PROPERTY_S_IRET, v);
        return result;
    }

    public List<E> findAllContainssIRET(SIRET v) throws TopiaException {
        List<E> result = findAllContains(FrenchCompany.PROPERTY_S_IRET, v);
        return result;
    }

    public E findBySIREN2(SIREN v) throws TopiaException {
        E result = findByProperty(FrenchCompany.PROPERTY_SIREN2, v);
        return result;
    }

    public List<E> findAllBySIREN2(SIREN v) throws TopiaException {
        List<E> result = findAllByProperty(FrenchCompany.PROPERTY_SIREN2, v);
        return result;
    }

    public E findContainsSIRET2(SIRET v) throws TopiaException {
        E result = findContains(FrenchCompany.PROPERTY_SIRET2, v);
        return result;
    }

    public List<E> findAllContainsSIRET2(SIRET v) throws TopiaException {
        List<E> result = findAllContains(FrenchCompany.PROPERTY_SIRET2, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        return new ArrayList<U>();
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        return new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>();
    }

} //FrenchCompanyDAOAbstract<E extends FrenchCompany>
