package org.nuiton.topiatest;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.nuiton.topia.TopiaException;
import org.nuiton.topia.TopiaTestDAOHelper.TopiaTestEntityEnum;
import org.nuiton.topia.persistence.TopiaDAOImpl;
import org.nuiton.topia.persistence.TopiaEntity;

public abstract class TypeDAOAbstract<E extends Type> extends TopiaDAOImpl<E> {

    @Override
    public Class<E> getEntityClass() {
        return (Class<E>)Type.class;
    }

    @Override
    public TopiaTestEntityEnum getTopiaEntityEnum() {
        return TopiaTestEntityEnum.Type;
    }

    @Override
    public void delete(E entity) throws TopiaException {
                                        {
                                        List<Product> list = getContext()
                                                    .getDAO(Product.class)
                                                    .findAllByProperties(Product.PROPERTY_TYPE, entity);
                                            for (Product item : list) {

                                                // sletellier : Set null only if target is concerned by deletion
                                                if (entity.equals(item.getType())) {
                                                    item.setType(null);
                                                }
                        
                    }
                }

        super.delete(entity);
    }

    public E findByName(String v) throws TopiaException {
        E result = findByProperty(Type.PROPERTY_NAME, v);
        return result;
    }

    public List<E> findAllByName(String v) throws TopiaException {
        List<E> result = findAllByProperty(Type.PROPERTY_NAME, v);
        return result;
    }

    @Override
    public <U extends TopiaEntity> List<U> findUsages(Class<U> type, E entity) throws TopiaException {
        List<?> result = new ArrayList();
        List tmp;

        if (type == Product.class) {
            ProductDAO dao = (ProductDAO)
                getContext().getDAO(Product.class);
            tmp = dao.findAllByType(entity);
            result.addAll(tmp);
        }

        return (List<U>) result;
    }

    @Override
    public Map<Class<? extends TopiaEntity>, List<? extends TopiaEntity>> findAllUsages(E entity) throws TopiaException {
        Map<Class<? extends TopiaEntity>,List<? extends TopiaEntity>> result;
        result = new HashMap<Class<? extends TopiaEntity>, List<? extends TopiaEntity>>(1);

        List<? extends TopiaEntity> list;

        list = findUsages(Product.class, entity);
        if (!list.isEmpty()) {
            result.put(Product.class, list);
        }

        return result;
    }

} //TypeDAOAbstract<E extends Type>
