package org.nuiton.topiatest.beangen;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;
import org.nuiton.i18n.I18n;
import org.nuiton.topiatest.Product;

public abstract class Roue implements Serializable {

    private static final long serialVersionUID = 7161394317488251190L;

    public static final String PROPERTY_VOITURE = "voiture";

    protected Voiture voiture;

    protected final PropertyChangeSupport pcs = new PropertyChangeSupport(this);

    static {
    
        I18n.n_("topia.test.common.roue");
        I18n.n_("topia.test.common.voiture");
    }

    public Voiture getVoiture() {
        return voiture;
    }

    public void setVoiture(Voiture voiture) {
        Voiture oldValue = getVoiture();
        this.voiture = voiture;
        firePropertyChange(PROPERTY_VOITURE, oldValue, voiture);
    }

    public abstract void mount();

    public abstract Product getModel(String id);

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        pcs.addPropertyChangeListener(listener);
    }

    public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        pcs.addPropertyChangeListener(propertyName, listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        pcs.removePropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        pcs.removePropertyChangeListener(propertyName, listener);
    }

    protected void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
        pcs.firePropertyChange(propertyName, oldValue, newValue);
    }

    protected void firePropertyChange(String propertyName, Object newValue) {
        firePropertyChange(propertyName, null, newValue);
    }

} //Roue
